program GraphikKonsole;

(* 	Carsten Thumulla im August 2006;
		Das Programm unterliegt der GPL gnu public license.
	*)

{$APPTYPE CONSOLE}

uses
	SysUtils, IniFiles, StrUtils;

const
	CNameSozialpaktdatei							= 'A_Sozialpakt'; 			// Name der Hauptdatei mit Startdaten, aktuellen Daten und Monatshistorie
	CDateiendung											= '.soz'; 							// Dateiendung aller Buchungsdateien
	CLesefehler												= Low(Integer); // -999999; // dieser Ausdruck wird zurckgegeben, wenn ein Lesefehler in der Datei auftrat

var
	Sozialpakt												: TMemIniFile; 					// Hauptdatei mit Startdaten, aktuellen Daten und Monatshistorie
	Buchungsmonat											: String; 							// Monatskennung z.B. '200608'
	GraphFileA												: TextFile;
	GraphFileB												: TextFile;

	procedure MachGraph;
	var 	i 				: Integer;

		// Monatskennung weiterzhlen
		function NaechsterMonat(JahrMonat : String) : String;
		var 	Jahr, Monat				: String;
					J, M 							: Integer;
		begin
			J := StrToInt(LeftStr(JahrMonat, 4));
			M := StrToInt(MidStr(JahrMonat, 5, 2));
			if M < 12
			then Inc(M)
			else begin
				 Inc(J);
				 M := 1;
			end;
			Jahr 	:= IntToStr(J);
			Monat := IntToStr(M);
			if Length(Monat) = 1 then Monat := '0' + Monat;
			Result := Jahr + Monat;
		end;

	begin
		Sozialpakt := TMemIniFile.Create(CNameSozialpaktdatei + CDateiendung);
		try
			Buchungsmonat := Sozialpakt.ReadString('Startdaten', 'Buchungsmonat', Buchungsmonat);
			AssignFile(GraphFileA, 'SozA.dat');
			Rewrite(GraphFileA);
			AssignFile(GraphFileB, 'SozB.dat');
			Rewrite(GraphFileB);

			i := 0;
			while Sozialpakt.SectionExists('Monat' + Buchungsmonat) do begin

				Writeln(GraphFileA, i, '   ', Sozialpakt.ReadFloat('Monat' + Buchungsmonat, 'Summe', CLesefehler));
				Writeln(GraphFileB, i, '   ', Sozialpakt.ReadFloat('Monat' + Buchungsmonat, 'Sozialanteil', CLesefehler));

				// Monat weiterzhlen
				Buchungsmonat := NaechsterMonat(Buchungsmonat);

				Inc(i);
			end;

			CloseFile(GraphFileA);
			CloseFile(GraphFileB);
		finally
			Sozialpakt.Free;
		end;
	end;

begin
	MachGraph;
end.


